package com.gestalt.sip.utilities.message;

/**
 * @author : csturtz
 */
public interface ClientAuthenticationMethod {
    /**
     * Initialize the Client authentication method. This has to be
     * done outside the constructor.
     * @param realm Realm
     * @param userName Username
     * @param uri URI
     * @param nonce Nonce
     * @param password Password
     * @param method Method
     * @param cnonce Cnonce
     * @param algorithm Alg
     * @throws Exception if the parameters are not correct.
     */
    public void initialize(String realm,
                           String userName,
                           String uri,
                           String nonce,
                           String password,
                           String method,
                           String cnonce,
                           String algorithm) throws Exception;

    /**
     * Generate the response.
     * @return null if the parameters given in the initialization are not
     * correct.
     */
    public String generateResponse();
}
